/*
 * Cfsc_ui.c - User interface object initialization functions.
 * This file was generated by `gxv' from `Cfsc.G'.
 */

#ifdef CFSC_XVIEW

#include <stdio.h>
#include <string.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/scrollbar.h>
#include <xview/svrimage.h>
#include <xview/termsw.h>
#include <xview/text.h>
#include <xview/tty.h>
#include <xview/xv_xrect.h>
#include <xview/notice.h>

#include "core.ext"
#include "utility.h"
#include "cfsc.ext"
#include "cfsutil.ext"
#include "display.ext"
#include "cfsio.ext"

static Xv_opaque editCfscLoadMenu;
static Xv_opaque editCfscSaveMenu;
Xv_opaque editCfscSubframe;
static Xv_opaque editCfscControls;
static Xv_opaque editCfscChoice1;
static Xv_opaque editCfscFormatChoice;
static Xv_opaque editCfscResizeButton;
static Xv_opaque editCfscList1;
static Xv_opaque editCfscClfInfo;
static Xv_opaque editCfscTextField1;
static Xv_opaque editCfscAddClfButton;
static Xv_opaque editCfscClearClfButton;
static Xv_opaque editCfscAddMsgButton;
static Xv_opaque editCfscClearMsgButton;
static Xv_opaque editCfscList2;
static Xv_opaque editCfscChoice2;
static Xv_opaque editCfscChoice3;
static Xv_opaque editCfscTextField2;
static Xv_opaque editCfscTextField3;
static Xv_opaque editCfscEntryButton;
static Xv_opaque editCfscSeekButton;
static Xv_opaque editCfscLoadButton;
static Xv_opaque editCfscExecButton;
static Xv_opaque editCfscSaveButton;
static Xv_opaque editCfscModifyButton;
static Xv_opaque editCfscOkButton;
static Xv_opaque editCfscCancelButton;
static Xv_opaque editCfscStepsTextField;
static Xv_opaque editCfscStepsButton;
static Xv_opaque editCfscOneStepButton;
static Xv_opaque editCfscEnvButton;
static Xv_opaque editCfscEnvCmdButton;

#define XV_SET(item,attr,cond) if (xv_get((item),(attr))!=(cond))\
    xv_set((item),(attr),(cond),NULL);
#define EDITCFSC_LIST2_TITLE "Msg-Id Message Producer Intensity Type"

/* Prototypes: */
static void editCfscFillList1(void);


/* ------------ modifications subwindow -------- */

static Xv_opaque paramsSubframe;
static Xv_opaque paramsType,paramsText1,paramsText2,paramsText3,paramsText4,paramsChoice1,paramsChoice2;
static void (*paramsCallback)();
static double paramsPlist[10];

/*
 * ParametrizedModifyCfsc
 * ----------------------
 *  Performs the modifications described by the parameter
 *  list plist.
 */
void ParametrizedModifyCfsc(void) {
    int i;
    char parString[60];
    double *plist=paramsPlist;
    switch ((int)plist[0]) {
	case 0: /* Generate Random Classifiers */
	sprintf(parString,"%7.0f",plist[1]);
	if (plist[2]==0) {
	    strcat(parString,",");
	} else {
	    sprintf(parString+strlen(parString),",%10.2f",
		plist[2]);
	}
	if (plist[3]==0) {
	    strcat(parString,",");
	} else {
	    sprintf(parString+strlen(parString),",%6.5f",
		plist[3]);
	}
	sprintf(parString+strlen(parString),",%s,%s",
		plist[5]==1 ? "ra" : "",
		plist[4]==1 ? "i"  : "");
	/* Remove unused commas: */
	for (i=strlen(parString)-1;i!=0 && parString[i]==',';i--) 
	    parString[i]='\0';
	GnRndCfs(parString);
    }
}

/* 
 * paramsDoneProc
 * --------------
 *  Done procedure called when user takes pin out.
 */
static void paramsDoneProc(void)  {
    xv_set(paramsSubframe,
	   FRAME_CMD_PIN_STATE,FRAME_CMD_PIN_OUT,
	   XV_SHOW,FALSE,
	   NULL);
}
/*
 *  paramsChoiceCB
 *  --------------
 *	The choice callback function.
 */
static void paramsChoiceCB(void) {
    switch(xv_get(paramsType,PANEL_VALUE)) {
	case 0: /* Generate Random Classifiers */
	xv_set(paramsText1,
	        XV_SHOW,TRUE,
                PANEL_LABEL_STRING, "Number of Classifiers:",
                XV_X, 60,
	        NULL);
	xv_set(paramsText2,
	        XV_SHOW,TRUE,
                PANEL_LABEL_STRING, "Mean Strength (0='use Default'):",
	        PANEL_VALUE,"0",
                XV_X, 60,
	        NULL);
	xv_set(paramsText3,
	        XV_SHOW,TRUE,
                PANEL_LABEL_STRING, "Mean BidRatio (0='use Specifity'):",
                XV_X, 60,
	        PANEL_VALUE,"0",
	        NULL);
	xv_set(paramsText4,
                XV_SHOW,FALSE,
	        NULL);
	xv_set(paramsChoice1,
	        XV_SHOW,TRUE,
	        XV_X, 60,
	        PANEL_LABEL_STRING, "Replace old ones:",
	        PANEL_CHOICE_STRINGS,
		    "Yes", "No", NULL,
	        NULL);
	xv_set(paramsChoice2,
	        XV_SHOW,TRUE,
	        XV_X, 60,
	        PANEL_LABEL_STRING, "Action Types:",
	        PANEL_CHOICE_STRINGS,
		    "PASS only ", "Arbitrarly chosen", NULL,
	        NULL);
       	break;
    }
}

/*
 *  paramsCB
 *  --------
 *	The button callback function.
 */
static void paramsCB(void) {
    paramsPlist[0]=(double)xv_get(paramsType,PANEL_VALUE);
    paramsPlist[1]=atof((char *)xv_get(paramsText1,PANEL_VALUE));
    if (paramsPlist[1] <= 0) {
	    notice_prompt(paramsSubframe,NULL,
		      NOTICE_MESSAGE_STRINGS,"Invalid Number of Classifiers!",NULL,
		      NOTICE_BUTTON_YES, "Cancel",
		      NULL);
	    return;
    }
    paramsPlist[2]=atof((char *)xv_get(paramsText2,PANEL_VALUE));
    if (paramsPlist[2] < 0) {
	    notice_prompt(paramsSubframe,NULL,
		      NOTICE_MESSAGE_STRINGS,"Invalid Mean Strength!",NULL,
		      NOTICE_BUTTON_YES, "Cancel",
		      NULL);
	    return;
    }
    paramsPlist[3]=atof((char *)xv_get(paramsText3,PANEL_VALUE));
    if (paramsPlist[3] >1 || paramsPlist[3]< 0) {
	    notice_prompt(paramsSubframe,NULL,
		      NOTICE_MESSAGE_STRINGS,"Invalid Mean Bidratio!",NULL,
		      NOTICE_BUTTON_YES, "Cancel",
		      NULL);
	    return;
    }
    if (paramsPlist[0]==0) { /* Generate Random Classifiers: */
	paramsPlist[4]=xv_get(paramsChoice1,PANEL_VALUE)==0 ?
			1 : 0; /* ==1 means replace old */
	paramsPlist[5]=xv_get(paramsChoice2,PANEL_VALUE)==0 ?
			0 : 1; /* ==1 means choose Action type arbitrarly */
    }
    ParametrizedModifyCfsc();
    editCfscFillList1();
}

/*
 * ParametersCfsc
 * --------------
 * Enter parameters for parametrized modification of Classifier
 * Systems provided by parametrizedModifyCfs() (see below).
 * After the user has confirmed the input of his parameters, 
 * callback is performed. 
 */
void ParametersCfsc(void)
{
    Xv_opaque panel;
    static firstTime=TRUE;
    if (! firstTime)  {
	xv_set(paramsSubframe,XV_SHOW,TRUE,NULL);
    } else {
	firstTime=FALSE;
	paramsSubframe=xv_create(editCfscSubframe,FRAME_CMD,
                XV_WIDTH, 435,
                XV_HEIGHT, 210,
                XV_LABEL, "Modifications for CFS-C:",
                FRAME_SHOW_FOOTER, FALSE,
                FRAME_SHOW_RESIZE_CORNER, FALSE,
                FRAME_CMD_PUSHPIN_IN, FALSE,
		XV_SHOW,TRUE,
		FRAME_DONE_PROC, paramsDoneProc,
                NULL);
	panel=xv_create(paramsSubframe, PANEL,
                XV_X, 0,
                XV_Y, 0,
                XV_WIDTH, WIN_EXTEND_TO_EDGE,
                XV_HEIGHT, WIN_EXTEND_TO_EDGE,
                WIN_BORDER, FALSE,
                NULL);
	paramsType=xv_create(panel, PANEL_CHOICE, PANEL_DISPLAY_LEVEL, PANEL_CURRENT,
                XV_X, 40,
                XV_Y, 8,
                PANEL_CHOICE_NCOLS, 1,
                PANEL_LAYOUT, PANEL_HORIZONTAL,
                PANEL_LABEL_STRING, "Modification Type:",
                PANEL_CHOICE_STRINGS,
                        "Generate Random Classifier",
                        NULL,
		PANEL_NOTIFY_PROC, paramsChoiceCB,
                NULL);
	paramsText1=xv_create(panel, PANEL_TEXT,
		XV_Y, 50,
		XV_SHOW,FALSE,
                PANEL_VALUE_DISPLAY_LENGTH, 8,
                PANEL_VALUE_STORED_LENGTH, 80,
                PANEL_LAYOUT, PANEL_HORIZONTAL,
                PANEL_READ_ONLY, FALSE,
                NULL);
	paramsText2=xv_create(panel, PANEL_TEXT,
		XV_Y,74,
		XV_SHOW,FALSE,
                PANEL_VALUE_DISPLAY_LENGTH, 8,
                PANEL_VALUE_STORED_LENGTH, 80,
                PANEL_LAYOUT, PANEL_HORIZONTAL,
                PANEL_READ_ONLY, FALSE,
                NULL);

	paramsText3=xv_create(panel, PANEL_TEXT,
		XV_SHOW,FALSE,
                XV_Y, 98,
                PANEL_VALUE_DISPLAY_LENGTH, 8,
                PANEL_VALUE_STORED_LENGTH, 80,
                PANEL_LAYOUT, PANEL_HORIZONTAL,
                PANEL_READ_ONLY, FALSE,
                NULL);
	paramsText4=xv_create(panel, PANEL_TEXT,
		XV_SHOW,FALSE,
                XV_Y, 122,
                PANEL_VALUE_DISPLAY_LENGTH, 8,
                PANEL_VALUE_STORED_LENGTH, 80,
                PANEL_LAYOUT, PANEL_HORIZONTAL,
                PANEL_READ_ONLY, FALSE,
                NULL);
	paramsChoice1=xv_create(panel, PANEL_CHOICE, PANEL_DISPLAY_LEVEL, PANEL_CURRENT,
		XV_SHOW,FALSE,
                XV_Y, 122,
                PANEL_CHOICE_NCOLS, 1,
                PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_NOTIFY_PROC, paramsChoiceCB,
                NULL);
	paramsChoice2=xv_create(panel, PANEL_CHOICE, PANEL_DISPLAY_LEVEL, PANEL_CURRENT,
		XV_SHOW,FALSE,
                XV_Y, 146,
                PANEL_CHOICE_NCOLS, 1,
                PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_NOTIFY_PROC, paramsChoiceCB,
                NULL);
	xv_create(panel,PANEL_BUTTON,
		XV_X, 90,
                XV_Y, 175,
                PANEL_LABEL_STRING, "Start Modification",
		PANEL_NOTIFY_PROC, paramsCB,
                NULL);
	xv_create(panel,PANEL_BUTTON,
                XV_X, 250,
                XV_Y, 175,
                PANEL_LABEL_STRING, "Cancel",
		PANEL_NOTIFY_PROC, paramsDoneProc,
                NULL);
    }
    paramsChoiceCB();
}



/* ------------- main window ------------- */

static void editCfscFillList1(void) {
    int i,j,ch;
    struct CfNode *cptr;
    char *charptr[2]={ NULL,NULL };
    extern void DisCfIE();

    xv_set(editCfscList1,XV_SHOW,FALSE,NULL);
    j=xv_get(editCfscList1,PANEL_LIST_NROWS);
    xv_set(editCfscList1,PANEL_LIST_DELETE_ROWS,0,j,NULL);
    ch=xv_get(editCfscChoice1,PANEL_VALUE);
    for (cptr=HiStrCf,i=0; i<NmCfs; cptr=cptr->PrvStrCf,i++) {
	if (ch==0 || (ch==1 && cptr->NmMtch>0) || (ch==2 && cptr->NmProd>0)
	    || (ch==3 && cptr->NmPost>0)) { 
	    if (xv_get(editCfscFormatChoice,PANEL_VALUE)<2)
		PutCNd(cptr,GCfBuff,1+xv_get(editCfscFormatChoice,PANEL_VALUE));
	    else 
		DisCfIE(cptr,GCfBuff,21+xv_get(editCfscFormatChoice,PANEL_VALUE)-2);
	    charptr[0]=GCfBuff;
	    xv_set(editCfscList1,PANEL_LIST_INSERT_STRINGS,i+1,charptr,NULL); 
	}
    } 
    XV_SET(editCfscAddClfButton,PANEL_INACTIVE,ch==1||ch==2||ch==3);
    sprintf(GOutBuff,"%d Classifiers,  Average Classifier Strength: %12.4f,   Cycle Step: %d",NmCfs,AveCfStr,CycleStp);
    xv_set(editCfscClfInfo,PANEL_LABEL_STRING,GOutBuff,NULL);
    xv_set(editCfscList1,XV_SHOW,TRUE,NULL);
}

static void editCfscFillList2(void) {
    int i,j,ch,maxcount;
    struct MsgNode *mptr;
    char *charptr[2]={ NULL,NULL };

    xv_set(editCfscList2,XV_SHOW,FALSE,NULL);
    j=xv_get(editCfscList2,PANEL_LIST_NROWS);
    xv_set(editCfscList2,PANEL_LIST_DELETE_ROWS,0,j,NULL);
    ch=xv_get(editCfscChoice2,PANEL_VALUE);
    if (ch==0) { 
	mptr=CurMsgs;
	maxcount=LastCMsg;
    }
    if (ch==1) {
	mptr=OldMsgs;
	maxcount=LastOMsg;
    }
    if (ch!=2) { /* Display a Message List */ 
	for (i=0; i<=maxcount; mptr++,i++) {
	    PutMNd(mptr,GCfBuff,1);
	    switch (mptr->Message[0]>>(LOCIPRI(0)-2)) {
		case 0: strcat(GCfBuff,"  [D]");
		break;
		case 1: strcat(GCfBuff,"  [X]");
		break;
		case 3: strcat(GCfBuff,"  [Y]");
		break;
		case 2: strcat(GCfBuff,"  [G]");
		break;
	    }
	    if (mptr->IsMsg) strcat(GCfBuff," p");
	    charptr[0]=GCfBuff;
	    xv_set(editCfscList2,PANEL_LIST_INSERT_STRINGS,i+1,charptr,NULL); 
	}
    } else { /* Display Brain Variables: */
	j=cfsc_sEntry(-1,GCfBuff);
	for (i=0;i<j;i++) {
	    cfsc_sEntry(i,GCfBuff);
	    strcat(GCfBuff,": ");
	    cfsc_sOut(Cfsc,i,GCfBuff+strlen(GCfBuff),CFBUFSZ-strlen(GCfBuff));
	    charptr[0]=GCfBuff;
	    *GCfBuff=toupper(*GCfBuff);
	    xv_set(editCfscList2,PANEL_LIST_INSERT_STRINGS,i+1,charptr,NULL); 
	}
    }
    XV_SET(editCfscAddMsgButton,PANEL_INACTIVE,ch==2);
    XV_SET(editCfscClearMsgButton,PANEL_INACTIVE,ch==2);
    XV_SET(editCfscEntryButton,PANEL_INACTIVE,ch!=2);
    XV_SET(editCfscSeekButton,PANEL_INACTIVE,ch!=2);
    xv_set(editCfscList2,PANEL_LIST_TITLE,ch==2?NULL:EDITCFSC_LIST2_TITLE,NULL);
    xv_set(editCfscList2,PANEL_LIST_DISPLAY_ROWS,ch==2?6:5,NULL);
    xv_set(editCfscList2,XV_SHOW,TRUE,NULL);
}

static Menu_item editCfscLoadMenuCB(item, op)
        Menu_item       item;
        Menu_generate   op;
{
    int i;
    FILE *f;
    extern void ReadEnv (FILE *f);

    if (op==MENU_NOTIFY) {
	if ((f=fopen((char *)xv_get(editCfscTextField3,PANEL_VALUE),"r"))==NULL) {
	    notice_prompt(editCfscSubframe,NULL,
		      NOTICE_MESSAGE_STRINGS,"Couldn't open file!",NULL,
		      NOTICE_BUTTON_YES, "Continue",
		      NULL);
	    return item;
	}
	i=xv_get(item,MENU_SELECTED);
	switch (i) {
	  case 6: /* Load Entire System: */
            ReadMsgs (f, 'r', 'o');
            ReadMsgs (f, 'r', 'c');
	    ReadCfs (f, 'r');
	    LinkCMs (); 
	    ReadEnv(f);
	    ReadVars (f);
	    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER,"Complete system loaded.",NULL);
	    break;
	  case 5: /* Load Environment: */
	    ReadEnv(f);
	    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER,"Environment loaded.",NULL);
	    break;
	  case 1: /* Load Clf from pure Classifier file: */
	    ReadCfs (f, 'r');
	    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER,"Classifiers loaded, no Clf-Msg-Linking done.",NULL);
	    break;
	  case 2: /* Load Current Msgs from pure Msg file: */
	    ReadMsgs (f, 'r', 'c'); 
	    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER,"Current Messages loaded, no Clf-Msg-Linking done.",NULL);
	    break;
	  case 3: /* Load Old Msgs from pure Msg file: */
	    ReadMsgs (f, 'r', 'o');
	    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER,"Old Messages loaded, no Clf-Msg-Linking done.",NULL);
            break;
	  case 4: /* Load Variables from pure Var file: */
	    ReadVars (f);
	    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER,"Variables loaded.",NULL);
	    break;
	  case 7: /* Link Classifiers to Messages and Messges to Messages */
	    LinkCMs();
	    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER,"Classifier-Message-Linking done.",NULL);
	    break;
	}
	fclose(f);
	editCfscFillList1();
	editCfscFillList2();
    }
    return item;
}

static Menu_item editCfscSaveMenuCB(item, op)
        Menu_item       item;
        Menu_generate   op;
{
    int i;
    FILE *f;
    if (op==MENU_NOTIFY) {
	if ((f=fopen((char *)xv_get(editCfscTextField3,PANEL_VALUE),"w"))==NULL) {
	    notice_prompt(editCfscSubframe,NULL,
		      NOTICE_MESSAGE_STRINGS,"Couldn't open file!",NULL,
		      NOTICE_BUTTON_YES, "Continue",
		      NULL);
	    return item;
	}
	i=xv_get(item,MENU_SELECTED);
	switch (i) {
	  case 1: /* Save Clf */
	    fprintf (f, ";  CLASSIFIERS\n");
	    WrtCfs (f, SAVEFMT);
	    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER,"Classifiers saved.",NULL);
	    break;
	  case 2: /* Save Current Msgs */
	    fprintf (f, ";  CUR-MSGLIST\n");
	    WrtMsgs (f, SAVEFMT, 'c');
	    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER,"Current Messages saved.",NULL);
	    break;
	  case 3: /* Save Old Msgs */
            fprintf (f, ";  OLD-MSGLIST\n");
	    WrtMsgs (f, SAVEFMT, 'o');
	    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER,"Old Messages saved.",NULL);
	    break;
	  case 4: /* Save Variables: */
	    fprintf (f, ";  VARIABLES\n");
	    PrnVars (f, SAVEFMT);   
    	    fprintf (f, "END-VARIABLES\n");
	    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER,"Variables saved.",NULL);
            break;
	  case 5: /* Save Environment: */
	    WrtEnv(f,SAVEFMT);
	    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER,"Environment saved.",NULL);
            break;
	  case 6: /* Save all */
	    fprintf (f, ";  CONSTANTS\n");
	    WrtCons (f);
	    fprintf (f, ";  OLD-MSGLIST\n");
	    WrtMsgs (f, SAVEFMT, 'o');
	    fprintf (f, ";  CUR-MSGLIST\n");
	    WrtMsgs (f, SAVEFMT, 'c');
	    fprintf (f, ";  CLASSIFIERS\n");
	    WrtCfs (f, SAVEFMT);
	    WrtEnv(f,SAVEFMT);
	    fprintf (f, ";  VARIABLES\n");
	    PrnVars (f, SAVEFMT);
	    fprintf (f, "END-VARIABLES\n");
	    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER,"Complete Brain saved.",NULL);
	    break;
	}
	fclose(f);
	editCfscFillList1();
	editCfscFillList2();
    }
    return item;
}

static void editCfscAddClfCB(void) {
    if (NmCfs>=CFLSTSZ) {
	notice_prompt(editCfscSubframe,NULL,
		      NOTICE_MESSAGE_STRINGS,"Too many Classifiers!",NULL,
		      NOTICE_BUTTON_YES, "Continue",
		      NULL);
	return;
    }
    if ( StoreCf((char *)xv_get(editCfscTextField1,PANEL_VALUE)) != TRUE ) {
	notice_prompt(editCfscSubframe,NULL,
		      NOTICE_MESSAGE_STRINGS,"Wrong Classifier Format!",NULL,
		      NOTICE_BUTTON_YES, "Continue",
		      NULL);
	return;
    }
    editCfscFillList1();
    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER,"Classifier added.",NULL);
}

static void editCfscEmptyCfLstCB() {
    InitCfLs();
    editCfscFillList1();
    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER,"Classifier List cleared.",NULL);
}

static void editCfscAddMsgCB(void) {
    int ch;
    ch=xv_get(editCfscChoice2,PANEL_VALUE);
    if ( ch==0 && NmCMsgIn>=NmIMsgMx || ch==1 && NmDetMsg>=NmDMsgMx ) {
	notice_prompt(editCfscSubframe,NULL,
		      NOTICE_MESSAGE_STRINGS,"Too many Messages!",NULL,
		      NOTICE_BUTTON_YES, "Continue",
		      NULL);
	return;
    }
    if ( StoreMsg((char *)xv_get(editCfscTextField1,PANEL_VALUE),
				 ch==0?'c':'o') != TRUE ) {
	notice_prompt(editCfscSubframe,NULL,
		      NOTICE_MESSAGE_STRINGS,"Wrong Message Format!",NULL,
		      NOTICE_BUTTON_YES, "Continue",
		      NULL);
	return;
    } 
    editCfscFillList2();
    sprintf(GOutBuff,"Message added to %s List.",ch==0?"Current":"Old");
    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER,GOutBuff,NULL);
}

static void editCfscClearMsgCB() {
    int ch;
    ch=xv_get(editCfscChoice2,PANEL_VALUE);
    EmptyML(ch==0?'c':'o');
    editCfscFillList2();
    sprintf(GOutBuff,"%s Message List cleared.",ch==0?"Current":"Old");
    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER,GOutBuff,NULL);
}

static void editCfscEntryCB(void) {
    int ch,i,j;
    char *c;
    ch=xv_get(editCfscChoice2,PANEL_VALUE);
    if (ch==2) {
	i=xv_get(editCfscList2,PANEL_LIST_FIRST_SELECTED);
	cfsc_sIn(Cfsc,i,(char *)xv_get(editCfscTextField2,PANEL_VALUE),
		xv_get(editCfscTextField2,PANEL_VALUE_STORED_LENGTH));
	strcpy(GOutBuff,(char *)xv_get(editCfscList2,PANEL_LIST_STRING,
			       xv_get(editCfscList2,PANEL_LIST_FIRST_SELECTED)));
	c=strchr(GOutBuff,':')+2;
	*c=0;
	strcat(GOutBuff,(char *)xv_get(editCfscTextField2,PANEL_VALUE));
	xv_set(editCfscList2,PANEL_LIST_STRING,
               (char *)xv_get(editCfscList2,PANEL_LIST_FIRST_SELECTED),
	       GOutBuff,NULL);
	xv_set(editCfscSubframe,FRAME_LEFT_FOOTER,"Variable set.",NULL);
    }
}

static void editCfscSeekCB(void) {
    int ch,i,j;
    char *c,buffer[80];
    ch=xv_get(editCfscChoice2,PANEL_VALUE);
    if (ch==2) {
	j=cfsc_sEntry(-1,GOutBuff);
	for (i=0;i<j;i++) {
	    cfsc_sEntry(i,GOutBuff);
	    for (c=GOutBuff;*c!='\0';c++) *c=tolower(*c);
	    strcpy(buffer,(char *)xv_get(editCfscTextField2,PANEL_VALUE));
	    for (c=buffer;*c!='\0';c++) *c=tolower(*c);
	    if (strncmp(GOutBuff,
		buffer,strlen(buffer)) == 0 )
		break;
	}
	if (i==j) {
	    notice_prompt(editCfscSubframe,NULL,
		      NOTICE_MESSAGE_STRINGS,"Unknown Variable!",NULL,
		      NOTICE_BUTTON_YES, "Continue",
		      NULL);
	    return;
	}
	xv_set(editCfscList2,PANEL_LIST_SELECT,i,TRUE,NULL);
	cfsc_sOut(Cfsc,i,GOutBuff,GOBUFFSZ);
	xv_set(editCfscTextField2,PANEL_VALUE,GOutBuff,NULL);
	xv_set(editCfscSubframe,FRAME_LEFT_FOOTER,"Variable found.",NULL);
    }
}

static void editCfscList2CB(void) {
    int ch,i,j;
    ch=xv_get(editCfscChoice2,PANEL_VALUE);
    if (ch==2) {
	i=xv_get(editCfscList2,PANEL_LIST_FIRST_SELECTED);
	cfsc_sOut(Cfsc,i,GOutBuff,GOBUFFSZ);
	xv_set(editCfscTextField2,PANEL_VALUE,GOutBuff,NULL);
    }
}

void editCfscFrameDoneCB(void) {
    xv_set(editCfscSubframe,FRAME_CMD_PIN_STATE,FRAME_CMD_PIN_OUT,
           XV_SHOW,FALSE,NULL);
    notify_stop();
}

void editCfscResizeCB(void) {
    int w;
    w=xv_get(editCfscSubframe,XV_WIDTH);
    xv_set(editCfscList1,
	   PANEL_LIST_WIDTH, (w-8)-20,
	   NULL);
    xv_set(editCfscList2,
	   PANEL_LIST_WIDTH, (w-8-330)-20,
	   NULL);
}

void editCfscExecCB(void) {
    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER, "performing...",NULL);
    ExecCmds((char *)xv_get(editCfscTextField3,PANEL_VALUE));
    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER, "Commands executed.",NULL);
    editCfscFillList1();
    editCfscFillList2();
}

void editCfscEnvCB(void) {
    extern int DsplEnv();
    DsplEnv("",DFLTFMT);
    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER, "Environment state displayed.",NULL);
}

void editCfscOneStepCB(void) {
    Classify("1");
    ReSrtCfs();
    editCfscFillList1();
    editCfscFillList2();
    if (xv_get(editCfscChoice3,PANEL_VALUE)==1) {
	editCfscEnvCB();
    }
    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER, "Classified one step.",NULL);
}

void editCfscStepsCB(void) {
    char str[30];
    sprintf(str,"%d",xv_get(editCfscStepsTextField,PANEL_VALUE));
    Classify(str);
    ReSrtCfs();
    editCfscFillList1();
    editCfscFillList2();
    if (xv_get(editCfscChoice3,PANEL_VALUE)==1) {
	editCfscEnvCB();
    }
    sprintf(GOutBuff,"Classified %d steps.",xv_get(editCfscStepsTextField,PANEL_VALUE));
    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER, GOutBuff,NULL);
}

void editCfscEnvCmdCB(void) {
    extern void DoEnvCmd();
    DoEnvCmd((char *)xv_get(editCfscTextField1,PANEL_VALUE));
    xv_set(editCfscSubframe,FRAME_LEFT_FOOTER, "Environment command executed.",NULL);
}

void editCfsc(Xv_opaque base) {
    static int firstTime=1;
    extern char Version[],ShortCRight[];
    if (firstTime) {
	firstTime=0;
	editCfscLoadMenu = xv_create(XV_NULL, MENU_COMMAND_MENU,
		MENU_GEN_PROC, editCfscLoadMenuCB,
		MENU_ITEM,
			MENU_STRING, "Classifiers",
			NULL,
		MENU_ITEM,
			MENU_STRING, "Current Message List",
			NULL,
		MENU_ITEM,
			MENU_STRING, "Old Message List",
			NULL,
		MENU_ITEM,
			MENU_STRING, "Variables",
			NULL,
		MENU_ITEM,
			MENU_STRING, "Environment",
			NULL,
		MENU_ITEM,
			MENU_STRING, "Complete System",
			NULL,
		MENU_ITEM,
			MENU_STRING, "Link Clf <-> Msgs",
			NULL,
		NULL);

	editCfscSaveMenu = xv_create(XV_NULL, MENU_COMMAND_MENU,
		MENU_GEN_PROC, editCfscSaveMenuCB,
		MENU_ITEM,
			MENU_STRING, "Classifiers",
			NULL,
		MENU_ITEM,
			MENU_STRING, "Current Message List",
			NULL,
		MENU_ITEM,
			MENU_STRING, "Old Message List",
			NULL,
		MENU_ITEM,
			MENU_STRING, "Variables",
			NULL,
		MENU_ITEM,
			MENU_STRING, "Environment",
			NULL,
		MENU_ITEM,
			MENU_STRING, "Complete System",
			NULL,
		NULL);

	sprintf(GOutBuff,"CFS-C Control Window   -    Version %s / %s",
		Version,ShortCRight);
	editCfscSubframe = xv_create(base, FRAME_CMD,
		XV_WIDTH, 681,
		XV_HEIGHT, 513,
		XV_LABEL, GOutBuff,
		FRAME_SHOW_FOOTER, TRUE,
		FRAME_SHOW_RESIZE_CORNER, TRUE,
		FRAME_CMD_PUSHPIN_IN, TRUE,
		FRAME_DONE_PROC, editCfscFrameDoneCB,
		FRAME_MIN_SIZE, 681, 513,
		NULL);
	xv_set(xv_get(editCfscSubframe, FRAME_CMD_PANEL), WIN_SHOW, TRUE, NULL);

	editCfscControls = xv_create(editCfscSubframe, PANEL,
		XV_X, 0,
		XV_Y, 0,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		WIN_BORDER, FALSE,
		NULL);
	
	editCfscChoice1 = xv_create(editCfscControls, PANEL_CHOICE, PANEL_DISPLAY_LEVEL, PANEL_CURRENT,
		XV_X, 16,
		XV_Y, 8,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_LABEL_STRING, "Display:",
		PANEL_CHOICE_STRINGS,
			"Classifier",
			"Matching Classifier",
			"Winning Classifier",
			"Posting Classifier",
			NULL,
		PANEL_NOTIFY_PROC, editCfscFillList1,
		NULL);
	
	editCfscFormatChoice = xv_create(editCfscControls, PANEL_CHOICE, PANEL_DISPLAY_LEVEL, PANEL_CURRENT,
		XV_X, 248,
		XV_Y, 8,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_LABEL_STRING, "Format:",
		PANEL_CHOICE_STRINGS,
			"Id, Classifier, Strength, BidRatio",
			"Statistics (see Manual)",
			"Environment Format #1",
			"Environment Format #2",
			NULL,
		PANEL_NOTIFY_PROC,editCfscFillList1,
		NULL);

	editCfscResizeButton = xv_create(editCfscControls, PANEL_BUTTON,
		XV_X, 560,
		XV_Y, 10,
		PANEL_LABEL_STRING, "Adjust Size",
		PANEL_NOTIFY_PROC, editCfscResizeCB,
		NULL);

	editCfscList1 = xv_create(editCfscControls, PANEL_LIST,
		XV_X, 8,
		XV_Y, 40,
		PANEL_LIST_WIDTH, 650,
		PANEL_LIST_DISPLAY_ROWS, 10,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_CHOOSE_ONE, TRUE,
		PANEL_CHOOSE_NONE, TRUE,
		PANEL_LIST_STRINGS,
			"m01010101 01010101, m0101010101010 ",
			NULL,
		NULL);

	editCfscClfInfo = xv_create(editCfscControls, PANEL_MESSAGE,
		XV_X, 50,
		XV_Y, 248,
		PANEL_LABEL_STRING, "",
		NULL);

	editCfscTextField1 = xv_create(editCfscControls, PANEL_TEXT,
		XV_X, 16,
		XV_Y, 272,
		PANEL_VALUE_DISPLAY_LENGTH, 82,
		PANEL_VALUE_STORED_LENGTH, 160,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		NULL);
	
	editCfscAddClfButton = xv_create(editCfscControls, PANEL_BUTTON,
		XV_X, 24,
		XV_Y, 296,
		PANEL_LABEL_STRING, "Add Classifier",
		PANEL_NOTIFY_PROC, editCfscAddClfCB,
		NULL);
	
	editCfscClearClfButton = xv_create(editCfscControls, PANEL_BUTTON,
		XV_X, 148,
		XV_Y, 296,
		PANEL_LABEL_STRING, "Empty Classifier List",
		PANEL_NOTIFY_PROC, editCfscEmptyCfLstCB,
		NULL);

	editCfscEnvCmdButton = xv_create(editCfscControls, PANEL_BUTTON,
		XV_X, 310,
		XV_Y, 296,
		PANEL_LABEL_STRING, "Env. Cmd",
		PANEL_NOTIFY_PROC, editCfscEnvCmdCB,
		NULL);

	editCfscAddMsgButton = xv_create(editCfscControls, PANEL_BUTTON,
		XV_X, 400,
		XV_Y, 296,
		PANEL_LABEL_STRING, "Add Message",
		PANEL_NOTIFY_PROC, editCfscAddMsgCB,
		NULL);

	editCfscClearMsgButton = xv_create(editCfscControls, PANEL_BUTTON,
		XV_X, 512,
		XV_Y, 296,
		PANEL_LABEL_STRING, "Empty Message List",
		PANEL_NOTIFY_PROC, editCfscClearMsgCB,
		NULL);

	editCfscList2 = xv_create(editCfscControls, PANEL_LIST,
		XV_X, 330,
		XV_Y, 336,
		PANEL_LIST_TITLE,EDITCFSC_LIST2_TITLE,
		PANEL_LIST_WIDTH, 320,
		PANEL_LIST_DISPLAY_ROWS, 5,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_CHOOSE_ONE, TRUE,
		PANEL_CHOOSE_NONE, TRUE,
		PANEL_NOTIFY_PROC, editCfscList2CB,
		NULL);

	editCfscChoice2 = xv_create(editCfscControls, PANEL_CHOICE, PANEL_DISPLAY_LEVEL, PANEL_CURRENT,
		XV_X, 26,
		XV_Y, 330,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_LABEL_STRING, "Display:",
		PANEL_CHOICE_STRINGS,
			"Current Message list",
			"Old Message List",
			"Brain Variables",
			NULL,
		PANEL_NOTIFY_PROC, editCfscFillList2,
		NULL);

	editCfscTextField2 = xv_create(editCfscControls, PANEL_TEXT,
		XV_X, 26,
		XV_Y, 362,
		PANEL_VALUE_DISPLAY_LENGTH, 36,
		PANEL_VALUE_STORED_LENGTH, 1024,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		NULL);

	editCfscEntryButton = xv_create(editCfscControls, PANEL_BUTTON,
		XV_X, 186,
		XV_Y, 384,
		PANEL_LABEL_STRING, "Accept Value",
		PANEL_NOTIFY_PROC, editCfscEntryCB,
		NULL);

	editCfscSeekButton = xv_create(editCfscControls, PANEL_BUTTON,
		XV_X, 34,
		XV_Y, 384,
		PANEL_LABEL_STRING, "Find Variable",
		PANEL_NOTIFY_PROC, editCfscSeekCB,
		NULL);

	editCfscLoadButton = xv_create(editCfscControls, PANEL_BUTTON,
		XV_X, 58,
		XV_Y, 416,
		PANEL_LABEL_STRING, "Load",
		PANEL_ITEM_MENU, editCfscLoadMenu,
		NULL);

	editCfscExecButton = xv_create(editCfscControls, PANEL_BUTTON,
		XV_X, 135,
		XV_Y, 416,
		PANEL_LABEL_STRING, "Exec",
		PANEL_NOTIFY_PROC, editCfscExecCB,
		NULL);

	editCfscSaveButton = xv_create(editCfscControls, PANEL_BUTTON,
		XV_X, 202,
		XV_Y, 416,
		PANEL_LABEL_STRING, "Save",
		PANEL_ITEM_MENU, editCfscSaveMenu,
		NULL);

	editCfscTextField3 = xv_create(editCfscControls, PANEL_TEXT,
		XV_X, 26,
		XV_Y, 445,
		PANEL_LABEL_STRING,"File:",
		PANEL_VALUE_DISPLAY_LENGTH, 30,
		PANEL_VALUE_STORED_LENGTH, 120,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		NULL);
	
	editCfscModifyButton = xv_create(editCfscControls, PANEL_BUTTON,
		XV_X, 530,
		XV_Y, 248,
		PANEL_LABEL_STRING, " Modifications... ",
		PANEL_NOTIFY_PROC, ParametersCfsc,
		NULL);

	editCfscChoice3 = xv_create(editCfscControls, PANEL_TOGGLE,
		XV_X, 26,
		XV_Y, 477,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_CHOICE_STRINGS,
			"Auto Show Env.",
			NULL,
		NULL);

	editCfscEnvButton = xv_create(editCfscControls, PANEL_BUTTON,
		XV_X, 170,
		XV_Y, 480,
		PANEL_LABEL_STRING, " Show Env.",
		PANEL_NOTIFY_PROC, editCfscEnvCB,
		NULL);

	editCfscStepsButton = xv_create(editCfscControls, PANEL_BUTTON,
		XV_X, 270,
		XV_Y, 480,
		PANEL_LABEL_STRING, " Classify: ",
		PANEL_NOTIFY_PROC, editCfscStepsCB,
		NULL);

	editCfscStepsTextField = xv_create(editCfscControls, PANEL_NUMERIC_TEXT,
		XV_X, 360,
		XV_Y, 480,
		PANEL_VALUE_DISPLAY_LENGTH, 8,
		PANEL_VALUE_STORED_LENGTH, 16,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_MIN_VALUE, 1,
		PANEL_MAX_VALUE, 999999,
		PANEL_VALUE, 500,
		NULL);

	editCfscOneStepButton = xv_create(editCfscControls, PANEL_BUTTON,
		XV_X, 475,
		XV_Y, 480,
		PANEL_LABEL_STRING, " One Step ",
		PANEL_NOTIFY_PROC, editCfscOneStepCB,
		NULL);

	editCfscCancelButton = xv_create(editCfscControls, PANEL_BUTTON,
		XV_X, 580,
		XV_Y, 480,
		PANEL_LABEL_STRING, "  Cancel  ",
		PANEL_NOTIFY_PROC, editCfscFrameDoneCB,
		NULL);
    } else {
	xv_set(editCfscSubframe,XV_SHOW,TRUE,
	       FRAME_CMD_PIN_STATE,FRAME_CMD_PUSHPIN_IN,NULL);
    }

    /* -------- Fill lists: -------- */
    editCfscFillList1();
    editCfscFillList2();
}

#endif /* CFSC_XVIEW */
